#!/usr/bin/env python

import time
import os, imp,sys
import uuid
import unittest
from dbs.apis.dbsClient import *
from ctypes import *
import socket

url=os.environ['DBS_WRITER_URL']
api = DbsApi(url=url)

def importCode(code,name,add_to_sys_modules=0):
    module = imp.new_module(name)
    exec code in module.__dict__
    if add_to_sys_modules:
        sys.modules[name] = module
    return module

class BlockInserttest:
    def __init__(self, concurrent=1, loops=1 ):
        self.concurrent=concurrent
        host=socket.gethostname()
        name=host[0:host.find('.')]
        #fn=name+str(time.time())
        fn=name+'_test_result.txt'
        self.output=open(fn, 'a') 
        self.concurrent=concurrent
        self.loops=loops
    def BlockInsert(self):
        self.output.write('concurrent=%s, loops=%s\n' %(self.concurrent, self.loops))
        for j in range(self.loops):
            #import pdb
            #pdb.set_trace()
            uid = uuid.uuid4().time_mid
            #print '****uid=%s****' %uid
            testparams['dataset_conf_list'][0]['app_name'] =\
                "%s_%s"%(testparams['dataset_conf_list'][0]['app_name'], uid)
            for i in range(len(testparams['file_conf_list'])):
                testparams['file_conf_list'][i]['app_name'] =\
                    "%s_%s"%(testparams['file_conf_list'][i]['app_name'], uid)
                testparams['file_conf_list'][i]['lfn'] =  "%s_%s"\
                    %(testparams['file_conf_list'][i]['lfn'],uid)

            for k in range(len(testparams['files'])):
                testparams['files'][k]['logical_file_name'] = "%s_%s"\
                    %(testparams['files'][k]['logical_file_name'], uid)
                if k == 0:
                    testparams['primds']['primary_ds_name'] =\
                    '%s_%s' %(testparams['primds']['primary_ds_name'],uid)
                    testparams['dataset']['dataset'] = \
                    '%s_%s' %(testparams['dataset']['dataset'],uid)
                    testparams['block']['block_name'] = \
                    '%s_%s' %(testparams['block']['block_name'],uid)
            #print  testparams
            t1=time.time()
            api.insertBlockBluk(blockDump=testparams)
            t2=time.time()
            dt=t2-t1
            self.output.write('t=%s, dt=%s;  ' %(t2,dt))

if __name__ == "__main__":
    t=time.time()
    delay=sys.argv[3]
    while 1:
        if time.time()-t > int(delay):
            #import pdb
            #pbs.set_trace()
            infofile=open("blockdump.dict","r")
            testparams=importCode(infofile, "testparams", 0).blockDump
            insert=BlockInserttest(concurrent=sys.argv[1], loops=int(sys.argv[2]))
            insert.BlockInsert()
            break
        else:
            time.sleep(1)
